import os,sys,random
from Bio import SeqIO


def SplitIntoPartners(record,len1):
    #splits a concatenated record into two 
    record1_seq = ''
    record2_seq = ''
    record_seq = record.seq.tostring() 
    
    record1_seq = record_seq[:len1]
    record2_seq = record_seq[len1:]
   
    return record1_seq, record2_seq


if __name__=="__main__":

   f = open('CoreLengthsSCOPPI.txt','r')
   lines = f.readlines() 
   f.close()

   core0_lengths = {}
   for line in lines:
       mode = line.split()[0]
       core0size = eval(line.split()[1])
       core0_lengths.setdefault(mode,core0size)
 

   if os.path.exists(sys.argv[1]):
   #for file in os.listdir('./PositiveData/'):
     
     #if not '_SelectedSamples_train.fasta' in file : continue
     file = sys.argv[1]
     f = open(file,'r')
     records = list(SeqIO.parse(f,'fasta'))
     f.close()

     mode = '_'.join(file.split('_')[:3])
     coreLen = core0_lengths[mode]

     f = open('./NegativeData/'+file[:-6]+'_negative.fasta','w')
   
     for i,record in enumerate(records):
       id0 = record.id.split('_')[0]
       record1_seq, record2_seq = SplitIntoPartners(record,coreLen)
       for idx in range(0,2):
           neg_idx = random.randint(0,len(records)-1)
           if neg_idx == i: continue
           neg_record = records[neg_idx]
       #try:
           id1 = neg_record.id.split('_')[0]
           if id0 == id1 : continue
       #except:
         #print neg_record.id
       
           neg1_seq, neg2_seq = SplitIntoPartners(neg_record,coreLen)
           print >> f, '>',record.id, neg_record.id
           if len(record.seq.tostring()) != len(record1_seq + neg2_seq):
              print len(record.seq.tostring()), len(record1_seq + neg2_seq)
           else:
              print >> f, record1_seq + neg2_seq

     f.close()   
   
