import math, os
#import pyddp as ddp
import cPickle
from cmap import ContactMap, ComplexInfo
from pdb import *

class Complex:

    def save(self, complex_file):
        f = open(complex_file, 'w')
        cPickle.dump(self, f, -1)
        f.close()

    def __str__(self):
        return self.pdbid+self.chains[0]+self.chains[1]

    def __init__(self, residues1, residues2):
        self.pdbid = residues1[0].get_full_id()[0]
        self.chains = (residues1[0].get_full_id()[2], residues2[0].get_full_id()[2])
	self.residueMap = [{},{}]
        for x in residues1:
	    #error if residue id contains insertion code! (only the residue which comes later will be written now)
            self.residueMap[0][x.get_id()[1]] = AA[x.get_resname()]
        for x in residues2:
            self.residueMap[1][x.get_id()[1]] = AA[x.get_resname()]
        self.contactMap = ContactMap(self.pdbid, self.chains, [residues1, residues2])

    def _insertGaps(self, seq, gappedSeq):
        out = []
        pos = 0
        for x in gappedSeq:
            if x == '-':
                out.append('-')
            else:
                out.append(seq[pos])
                pos += 1
        return out
    
    def intResidues(self, gappedSeq1 = None, gappedSeq2 = None):
        intMap1 = []
        cmap = self.contactMap
        for row in cmap:
            intMap1.append(str(int(sum([1 for x in row if x < TRUE_INT_DISTANCE]) > 0)))
        intMap2 = []
        for i in range(len(cmap[0])):
            intMap2.append(str(int(sum([1 for r in cmap if r[i] < TRUE_INT_DISTANCE]) > 0)))
        if gappedSeq1 and gappedSeq2:
            intMap1 = self._insertGaps(intMap1, gappedSeq1)
            intMap2 = self._insertGaps(intMap2, gappedSeq2)
        return ''.join(intMap1), ''.join(intMap2)

    def getResidues(self):
        res1 = [x[1] for x in sorted(self.residueMap[0].items(), key=lambda x: x[0])]
        res2 = [x[1] for x in sorted(self.residueMap[1].items(), key=lambda x: x[0])]
        return ''.join(res1), ''.join(res2)
        
    def sequence(self, num):
        seq = ''
        for i in self.contactMap.seq[num]:
            if i != -1:
                seq += self.residueMap[num][i]
            else:
                seq += '-'
        return seq
        
    def writePng(self, namebase):
        self.contactMap.saveImage(namebase)

def loadComplex(complex_file):
    f = open(complex_file, 'r')
    c = cPickle.load(f)
    f.close()
    return c

